#ifndef VISIBILITY_HH
#define VISIBILITY_HH

#define LOCAL __attribute__ ((visibility("hidden")))
#define PUBLIC __attribute__ ((visibility("default")))

class LOCAL Hidden
{
public :
  PUBLIC Hidden();
  PUBLIC ~Hidden();
  PUBLIC void doSomething();
  PUBLIC void setSomething(int);
private :
  int something;
};

template <typename T>
class Visible
{
public :
  Visible();
  ~Visible();
  void doSomething();
private :
  Hidden inner;
};

template <typename T>
Visible<T>::Visible() : inner() { };
template <typename T>
Visible<T>::~Visible() { };
template <typename T>
void Visible<T>::doSomething()
{
  inner.setSomething(1);
  inner.doSomething();
}

#endif
